VTK: vtkTransform Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkTransform Class Reference

describes linear transformations via a 4x4 matrix More...

`#include <vtkTransform.h>`

Inheritance diagram for vtkTransform:
[legend]
Collaboration diagram for vtkTransform:
[legend]

## Public Types
typedef vtkLinearTransform | Superclass
Public Types inherited from vtkLinearTransform
typedef vtkHomogeneousTransform | Superclass
Public Types inherited from vtkHomogeneousTransform
typedef vtkAbstractTransform | Superclass
Public Types inherited from vtkAbstractTransform
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkTransform * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Identity ()
| Set the transformation to the identity transformation. More...
void | Inverse () override
| Invert the transformation. More...
void | Concatenate (vtkLinearTransform *transform)
| Concatenate the specified transform with the current transformation according to PreMultiply or PostMultiply semantics. More...
void | PreMultiply ()
| Sets the internal state of the transform to PreMultiply. More...
void | PostMultiply ()
| Sets the internal state of the transform to PostMultiply. More...
int | GetNumberOfConcatenatedTransforms ()
| Get the total number of transformations that are linked into this one via Concatenate() operations or via SetInput(). More...
void | GetInverse (vtkMatrix4x4 *inverse)
| Return a matrix which is the inverse of the current transformation matrix. More...
void | GetTranspose (vtkMatrix4x4 *transpose)
| Return a matrix which is the transpose of the current transformation matrix. More...
vtkTypeBool | GetInverseFlag ()
| Get the inverse flag of the transformation. More...
int | CircuitCheck (vtkAbstractTransform *transform) override
| Check for self-reference. More...
vtkAbstractTransform * | GetInverse ()
vtkAbstractTransform * | MakeTransform () override
| Make a new transform of the same type. More...
vtkMTimeType | GetMTime () override
| Override GetMTime to account for input and concatenation. More...
void | Translate (double x, double y, double z)
| Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. More...
void | Translate (const double x[3])
| Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. More...
void | Translate (const float x[3])
| Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. More...
void | RotateWXYZ (double angle, double x, double y, double z)
| Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. More...
void | RotateWXYZ (double angle, const double axis[3])
| Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. More...
void | RotateWXYZ (double angle, const float axis[3])
| Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. More...
void | RotateX (double angle)
| Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. More...
void | RotateY (double angle)
| Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. More...
void | RotateZ (double angle)
| Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics. More...
void | Scale (double x, double y, double z)
| Create a scale matrix (i.e. More...
void | Scale (const double s[3])
| Create a scale matrix (i.e. More...
void | Scale (const float s[3])
| Create a scale matrix (i.e. More...
void | SetMatrix (vtkMatrix4x4 *matrix)
| Set the current matrix directly. More...
void | SetMatrix (const double elements[16])
| Set the current matrix directly. More...
void | Concatenate (vtkMatrix4x4 *matrix)
| Concatenates the matrix with the current transformation according to PreMultiply or PostMultiply semantics. More...
void | Concatenate (const double elements[16])
| Concatenates the matrix with the current transformation according to PreMultiply or PostMultiply semantics. More...
vtkLinearTransform * | GetConcatenatedTransform (int i)
| Get one of the concatenated transformations as a vtkAbstractTransform. More...
void | GetOrientation (double orient[3])
| Get the x, y, z orientation angles from the transformation matrix as an array of three floating point values. More...
void | GetOrientation (float orient[3])
| Get the x, y, z orientation angles from the transformation matrix as an array of three floating point values. More...
double * | GetOrientation ()
| Get the x, y, z orientation angles from the transformation matrix as an array of three floating point values. More...
void | GetOrientationWXYZ (double wxyz[4])
| Return the wxyz angle+axis representing the current orientation. More...
void | GetOrientationWXYZ (float wxyz[4])
| Return the wxyz angle+axis representing the current orientation. More...
double * | GetOrientationWXYZ ()
| Return the wxyz angle+axis representing the current orientation. More...
void | GetPosition (double pos[3])
| Return the position from the current transformation matrix as an array of three floating point numbers. More...
void | GetPosition (float pos[3])
| Return the position from the current transformation matrix as an array of three floating point numbers. More...
double * | GetPosition ()
| Return the position from the current transformation matrix as an array of three floating point numbers. More...
void | GetScale (double scale[3])
| Return the scale factors of the current transformation matrix as an array of three float numbers. More...
void | GetScale (float scale[3])
| Return the scale factors of the current transformation matrix as an array of three float numbers. More...
double * | GetScale ()
| Return the scale factors of the current transformation matrix as an array of three float numbers. More...
void | SetInput (vtkLinearTransform *input)
| Set the input for this transformation. More...
vtkLinearTransform * | GetInput ()
| Set the input for this transformation. More...
void | Push ()
| Pushes the current transformation onto the transformation stack. More...
void | Pop ()
| Deletes the transformation on the top of the stack and sets the top to the next transformation on the stack. More...
void | MultiplyPoint (const float in[4], float out[4])
| Use this method only if you wish to compute the transformation in homogeneous (x,y,z,w) coordinates, otherwise use TransformPoint(). More...
void | MultiplyPoint (const double in[4], double out[4])
| Use this method only if you wish to compute the transformation in homogeneous (x,y,z,w) coordinates, otherwise use TransformPoint(). More...
Public Member Functions inherited from vtkLinearTransform
vtkLinearTransform * | NewInstance () const
void | TransformNormal (const float in[3], float out[3])
| Apply the transformation to a normal. More...
void | TransformNormal (const double in[3], double out[3])
| Apply the transformation to a double-precision normal. More...
double * | TransformNormal (double x, double y, double z)
| Synonymous with TransformDoubleNormal(x,y,z). More...
double * | TransformNormal (const double normal[3])
double * | TransformVector (double x, double y, double z)
| Synonymous with TransformDoubleVector(x,y,z). More...
double * | TransformVector (const double normal[3])
void | TransformVector (const float in[3], float out[3])
| Apply the transformation to a vector. More...
void | TransformVector (const double in[3], double out[3])
| Apply the transformation to a double-precision vector. More...
void | TransformPoints (vtkPoints *inPts, vtkPoints *outPts) override
| Apply the transformation to a series of points, and append the results to outPts. More...
virtual void | TransformNormals (vtkDataArray *inNms, vtkDataArray *outNms)
| Apply the transformation to a series of normals, and append the results to outNms. More...
virtual void | TransformVectors (vtkDataArray *inVrs, vtkDataArray *outVrs)
| Apply the transformation to a series of vectors, and append the results to outVrs. More...
void | TransformPointsNormalsVectors (vtkPoints *inPts, vtkPoints *outPts, vtkDataArray *inNms, vtkDataArray *outNms, vtkDataArray *inVrs, vtkDataArray *outVrs, int nOptionalVectors=0, vtkDataArray **inVrsArr=nullptr, vtkDataArray **outVrsArr=nullptr) override
| Apply the transformation to a combination of points, normals and vectors. More...
vtkLinearTransform * | GetLinearInverse ()
| Just like GetInverse, but it includes a typecast to vtkLinearTransform. More...
float * | TransformFloatNormal (float x, float y, float z)
| Apply the transformation to an (x,y,z) normal. More...
float * | TransformFloatNormal (const float normal[3])
| Apply the transformation to an (x,y,z) normal. More...
double * | TransformDoubleNormal (double x, double y, double z)
| Apply the transformation to a double-precision (x,y,z) normal. More...
double * | TransformDoubleNormal (const double normal[3])
| Apply the transformation to a double-precision (x,y,z) normal. More...
float * | TransformFloatVector (float x, float y, float z)
| Apply the transformation to an (x,y,z) vector. More...
float * | TransformFloatVector (const float vec[3])
| Apply the transformation to an (x,y,z) vector. More...
double * | TransformDoubleVector (double x, double y, double z)
| Apply the transformation to a double-precision (x,y,z) vector. More...
double * | TransformDoubleVector (const double vec[3])
| Apply the transformation to a double-precision (x,y,z) vector. More...
void | InternalTransformPoint (const float in[3], float out[3]) override
| This will calculate the transformation without calling Update. More...
void | InternalTransformPoint (const double in[3], double out[3]) override
| This will calculate the transformation without calling Update. More...
virtual void | InternalTransformNormal (const float in[3], float out[3])
| This will calculate the transformation without calling Update. More...
virtual void | InternalTransformNormal (const double in[3], double out[3])
| This will calculate the transformation without calling Update. More...
virtual void | InternalTransformVector (const float in[3], float out[3])
| This will calculate the transformation without calling Update. More...
virtual void | InternalTransformVector (const double in[3], double out[3])
| This will calculate the transformation without calling Update. More...
void | InternalTransformDerivative (const float in[3], float out[3], float derivative[3][3]) override
| This will calculate the transformation as well as its derivative without calling Update. More...
void | InternalTransformDerivative (const double in[3], double out[3], double derivative[3][3]) override
| This will calculate the transformation as well as its derivative without calling Update. More...
Public Member Functions inherited from vtkHomogeneousTransform
vtkHomogeneousTransform * | NewInstance () const
void | GetMatrix (vtkMatrix4x4 *m)
| Get a copy of the internal transformation matrix. More...
vtkMatrix4x4 * | GetMatrix ()
| Get a pointer to an internal vtkMatrix4x4 that represents the transformation. More...
vtkHomogeneousTransform * | GetHomogeneousInverse ()
| Just like GetInverse(), but includes typecast to vtkHomogeneousTransform. More...
Public Member Functions inherited from vtkAbstractTransform
vtkAbstractTransform * | NewInstance () const
void | TransformPoint (const float in[3], float out[3])
| Apply the transformation to a coordinate. More...
void | TransformPoint (const double in[3], double out[3])
| Apply the transformation to a double-precision coordinate. More...
double * | TransformPoint (double x, double y, double z)
| Apply the transformation to a double-precision coordinate. More...
double * | TransformPoint (const double point[3])
double * | TransformNormalAtPoint (const double point[3], const double normal[3])
double * | TransformVectorAtPoint (const double point[3], const double vector[3])
vtkAbstractTransform * | GetInverse ()
| Get the inverse of this transform. More...
void | SetInverse (vtkAbstractTransform *transform)
| Set a transformation that this transform will be the inverse of. More...
void | DeepCopy (vtkAbstractTransform *)
| Copy this transform from another of the same type. More...
void | Update ()
| Update the transform to account for any changes which have been made. More...
void | UnRegister (vtkObjectBase *O) override
| Needs a special UnRegister() implementation to avoid circular references. More...
float * | TransformFloatPoint (float x, float y, float z)
| Apply the transformation to an (x,y,z) coordinate. More...
float * | TransformFloatPoint (const float point[3])
| Apply the transformation to an (x,y,z) coordinate. More...
double * | TransformDoublePoint (double x, double y, double z)
| Apply the transformation to a double-precision (x,y,z) coordinate. More...
double * | TransformDoublePoint (const double point[3])
| Apply the transformation to a double-precision (x,y,z) coordinate. More...
void | TransformNormalAtPoint (const float point[3], const float in[3], float out[3])
| Apply the transformation to a normal at the specified vertex. More...
void | TransformNormalAtPoint (const double point[3], const double in[3], double out[3])
| Apply the transformation to a normal at the specified vertex. More...
double * | TransformDoubleNormalAtPoint (const double point[3], const double normal[3])
| Apply the transformation to a double-precision normal at the specified vertex. More...
float * | TransformFloatNormalAtPoint (const float point[3], const float normal[3])
| Apply the transformation to a single-precision normal at the specified vertex. More...
void | TransformVectorAtPoint (const float point[3], const float in[3], float out[3])
| Apply the transformation to a vector at the specified vertex. More...
void | TransformVectorAtPoint (const double point[3], const double in[3], double out[3])
| Apply the transformation to a vector at the specified vertex. More...
double * | TransformDoubleVectorAtPoint (const double point[3], const double vector[3])
| Apply the transformation to a double-precision vector at the specified vertex. More...
float * | TransformFloatVectorAtPoint (const float point[3], const float vector[3])
| Apply the transformation to a single-precision vector at the specified vertex. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTransform * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkTransform * | SafeDownCast (vtkObjectBase *o)
static void | GetOrientation (double orient[3], vtkMatrix4x4 *matrix)
| Convenience function to get the x, y, z orientation angles from a transformation matrix as an array of three floating point values. More...
Static Public Member Functions inherited from vtkLinearTransform
static vtkTypeBool | IsTypeOf (const char *type)
static vtkLinearTransform * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkHomogeneousTransform
static vtkTypeBool | IsTypeOf (const char *type)
static vtkHomogeneousTransform * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAbstractTransform
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractTransform * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkTransform ()
| ~vtkTransform () override
void | InternalDeepCopy (vtkAbstractTransform *t) override
| Perform any subclass-specific DeepCopy. More...
void | InternalUpdate () override
| Perform any subclass-specific Update. More...
Protected Member Functions inherited from vtkLinearTransform
| vtkLinearTransform ()=default
| ~vtkLinearTransform () override=default
Protected Member Functions inherited from vtkHomogeneousTransform
| vtkHomogeneousTransform ()
| ~vtkHomogeneousTransform () override
Protected Member Functions inherited from vtkAbstractTransform
| vtkAbstractTransform ()
| ~vtkAbstractTransform () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkLinearTransform * | Input
vtkTransformConcatenation * | Concatenation
vtkTransformConcatenationStack * | Stack
vtkMTimeType | MatrixUpdateMTime
float | Point [4]
double | DoublePoint [4]
double | ReturnValue [4]
Protected Attributes inherited from vtkHomogeneousTransform
vtkMatrix4x4 * | Matrix
Protected Attributes inherited from vtkAbstractTransform
float | InternalFloatPoint [3]
double | InternalDoublePoint [3]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

describes linear transformations via a 4x4 matrix

A vtkTransform can be used to describe the full range of linear (also known as affine) coordinate transformations in three dimensions, which are internally represented as a 4x4 homogeneous transformation matrix. When you create a new vtkTransform, it is always initialized to the identity transformation.

The SetInput() method allows you to set another transform, instead of the identity transform, to be the base transformation. There is a pipeline mechanism to ensure that when the input is modified, the current transformation will be updated accordingly. This pipeline mechanism is also supported by the Concatenate() method.

Most of the methods for manipulating this transformation, e.g. Translate, Rotate, and Concatenate, can operate in either PreMultiply (the default) or PostMultiply mode. In PreMultiply mode, the translation, concatenation, etc. will occur before any transformations which are represented by the current matrix. In PostMultiply mode, the additional transformation will occur after any transformations represented by the current matrix.

This class performs all of its operations in a right handed coordinate system with right handed rotations. Some other graphics libraries use left handed coordinate systems and rotations.

See also
  vtkPerspectiveTransform vtkGeneralTransform vtkMatrix4x4 vtkTransformCollection vtkTransformFilter vtkTransformPolyDataFilter vtkImageReslice

Examples:
  vtkTransform (Examples)

Online Examples:

Tests:
  vtkTransform (Tests)

Definition at line 58 of file vtkTransform.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkLinearTransform vtkTransform::Superclass

Definition at line 62 of file vtkTransform.h.

## Constructor & Destructor Documentation

## ◆ vtkTransform()

vtkTransform::vtkTransform | ( |  | ) |
| protected

## ◆ ~vtkTransform()

vtkTransform::~vtkTransform | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkTransform* vtkTransform::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkTransform::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkTransform::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkLinearTransform.

## ◆ SafeDownCast()

static vtkTransform* vtkTransform::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkTransform::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkLinearTransform.

## ◆ NewInstance()

vtkTransform* vtkTransform::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkTransform::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkLinearTransform.

## ◆ Identity()

void vtkTransform::Identity | ( |  | ) |

Set the transformation to the identity transformation.

If the transform has an Input, then the transformation will be reset so that it is the same as the Input.

## ◆ Inverse()

void vtkTransform::Inverse | ( |  | ) |
| overridevirtual

Invert the transformation.

This will also set a flag so that the transformation will use the inverse of its Input, if an Input has been set.

Implements vtkAbstractTransform.

## ◆ Translate() [1/3]

void vtkTransform::Translate | ( | double | x,
|  | double | y,
|  | double | z
| ) |  |
| inline

Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics.

Definition at line 84 of file vtkTransform.h.

## ◆ Translate() [2/3]

void vtkTransform::Translate | ( | const double | x[3] | ) |
| inline

Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics.

Definition at line 85 of file vtkTransform.h.

## ◆ Translate() [3/3]

void vtkTransform::Translate | ( | const float | x[3] | ) |
| inline

Create a translation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics.

Definition at line 86 of file vtkTransform.h.

## ◆ RotateWXYZ() [1/3]

void vtkTransform::RotateWXYZ | ( | double | angle,
|  | double | x,
|  | double | y,
|  | double | z
| ) |  |
| inline

Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics.

The angle is in degrees, and (x,y,z) specifies the axis that the rotation will be performed around.

Definition at line 96 of file vtkTransform.h.

## ◆ RotateWXYZ() [2/3]

void vtkTransform::RotateWXYZ | ( | double | angle,
|  | const double | axis[3]
| ) |  |
| inline

Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics.

The angle is in degrees, and (x,y,z) specifies the axis that the rotation will be performed around.

Definition at line 100 of file vtkTransform.h.

## ◆ RotateWXYZ() [3/3]

void vtkTransform::RotateWXYZ | ( | double | angle,
|  | const float | axis[3]
| ) |  |
| inline

Create a rotation matrix and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics.

The angle is in degrees, and (x,y,z) specifies the axis that the rotation will be performed around.

Definition at line 104 of file vtkTransform.h.

## ◆ RotateX()

void vtkTransform::RotateX | ( | double | angle | ) |
| inline

Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics.

The angle is expressed in degrees.

Definition at line 116 of file vtkTransform.h.

## ◆ RotateY()

void vtkTransform::RotateY | ( | double | angle | ) |
| inline

Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics.

The angle is expressed in degrees.

Definition at line 117 of file vtkTransform.h.

## ◆ RotateZ()

void vtkTransform::RotateZ | ( | double | angle | ) |
| inline

Create a rotation matrix about the X, Y, or Z axis and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics.

The angle is expressed in degrees.

Definition at line 118 of file vtkTransform.h.

## ◆ Scale() [1/3]

void vtkTransform::Scale | ( | double | x,
|  | double | y,
|  | double | z
| ) |  |
| inline

Create a scale matrix (i.e.

set the diagonal elements to x, y, z) and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics.

Definition at line 127 of file vtkTransform.h.

## ◆ Scale() [2/3]

void vtkTransform::Scale | ( | const double | s[3] | ) |
| inline

Create a scale matrix (i.e.

set the diagonal elements to x, y, z) and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics.

Definition at line 128 of file vtkTransform.h.

## ◆ Scale() [3/3]

void vtkTransform::Scale | ( | const float | s[3] | ) |
| inline

Create a scale matrix (i.e.

set the diagonal elements to x, y, z) and concatenate it with the current transformation according to PreMultiply or PostMultiply semantics.

Definition at line 129 of file vtkTransform.h.

## ◆ SetMatrix() [1/2]

void vtkTransform::SetMatrix | ( | vtkMatrix4x4 * | matrix | ) |
| inline

Set the current matrix directly.

Note: First, the current matrix is set to the identity, then the input matrix is concatenated.

Definition at line 137 of file vtkTransform.h.

## ◆ SetMatrix() [2/2]

void vtkTransform::SetMatrix | ( | const double | elements[16] | ) |
| inline

Set the current matrix directly.

Note: First, the current matrix is set to the identity, then the input matrix is concatenated.

Definition at line 138 of file vtkTransform.h.

## ◆ Concatenate() [1/3]

void vtkTransform::Concatenate | ( | vtkMatrix4x4 * | matrix | ) |
| inline

Concatenates the matrix with the current transformation according to PreMultiply or PostMultiply semantics.

Definition at line 150 of file vtkTransform.h.

## ◆ Concatenate() [2/3]

void vtkTransform::Concatenate | ( | const double | elements[16] | ) |
| inline

Concatenates the matrix with the current transformation according to PreMultiply or PostMultiply semantics.

Definition at line 151 of file vtkTransform.h.

## ◆ Concatenate() [3/3]

void vtkTransform::Concatenate | ( | vtkLinearTransform * | transform | ) |

Concatenate the specified transform with the current transformation according to PreMultiply or PostMultiply semantics.

The concatenation is pipelined, meaning that if any of the transformations are changed, even after Concatenate() is called, those changes will be reflected when you call TransformPoint().

## ◆ PreMultiply()

void vtkTransform::PreMultiply | ( |  | ) |
| inline

Sets the internal state of the transform to PreMultiply.

All subsequent operations will occur before those already represented in the current transformation. In homogeneous matrix notation, M = M*A where M is the current transformation matrix and A is the applied matrix. The default is PreMultiply.

Definition at line 170 of file vtkTransform.h.

## ◆ PostMultiply()

void vtkTransform::PostMultiply | ( |  | ) |
| inline

Sets the internal state of the transform to PostMultiply.

All subsequent operations will occur after those already represented in the current transformation. In homogeneous matrix notation, M = A*M where M is the current transformation matrix and A is the applied matrix. The default is PreMultiply.

Definition at line 187 of file vtkTransform.h.

## ◆ GetNumberOfConcatenatedTransforms()

int vtkTransform::GetNumberOfConcatenatedTransforms | ( |  | ) |
| inline

Get the total number of transformations that are linked into this one via Concatenate() operations or via SetInput().

Definition at line 201 of file vtkTransform.h.

## ◆ GetConcatenatedTransform()

vtkLinearTransform* vtkTransform::GetConcatenatedTransform | ( | int | i | ) |
| inline

Get one of the concatenated transformations as a vtkAbstractTransform.

These transformations are applied, in series, every time the transformation of a coordinate occurs. This method is provided to make it possible to decompose a transformation into its constituents, for example to save a transformation to a file.

Definition at line 214 of file vtkTransform.h.

## ◆ GetOrientation() [1/4]

void vtkTransform::GetOrientation | ( | double | orient[3] | ) |

Get the x, y, z orientation angles from the transformation matrix as an array of three floating point values.

## ◆ GetOrientation() [2/4]

void vtkTransform::GetOrientation | ( | float | orient[3] | ) |
| inline

Get the x, y, z orientation angles from the transformation matrix as an array of three floating point values.

Definition at line 247 of file vtkTransform.h.

## ◆ GetOrientation() [3/4]

double* vtkTransform::GetOrientation | ( |  | ) |
| inline

Get the x, y, z orientation angles from the transformation matrix as an array of three floating point values.

Definition at line 255 of file vtkTransform.h.

## ◆ GetOrientation() [4/4]

static void vtkTransform::GetOrientation | ( | double | orient[3],
|  | vtkMatrix4x4 * | matrix
| ) |  |
| static

Convenience function to get the x, y, z orientation angles from a transformation matrix as an array of three floating point values.

## ◆ GetOrientationWXYZ() [1/3]

void vtkTransform::GetOrientationWXYZ | ( | double | wxyz[4] | ) |

Return the wxyz angle+axis representing the current orientation.

The angle is in degrees and the axis is a unit vector.

## ◆ GetOrientationWXYZ() [2/3]

void vtkTransform::GetOrientationWXYZ | ( | float | wxyz[4] | ) |
| inline

Return the wxyz angle+axis representing the current orientation.

The angle is in degrees and the axis is a unit vector.

Definition at line 274 of file vtkTransform.h.

## ◆ GetOrientationWXYZ() [3/3]

double* vtkTransform::GetOrientationWXYZ | ( |  | ) |
| inline

Return the wxyz angle+axis representing the current orientation.

The angle is in degrees and the axis is a unit vector.

Definition at line 283 of file vtkTransform.h.

## ◆ GetPosition() [1/3]

void vtkTransform::GetPosition | ( | double | pos[3] | ) |

Return the position from the current transformation matrix as an array of three floating point numbers.

This is simply returning the translation component of the 4x4 matrix.

## ◆ GetPosition() [2/3]

void vtkTransform::GetPosition | ( | float | pos[3] | ) |
| inline

Return the position from the current transformation matrix as an array of three floating point numbers.

This is simply returning the translation component of the 4x4 matrix.

Definition at line 297 of file vtkTransform.h.

## ◆ GetPosition() [3/3]

double* vtkTransform::GetPosition | ( |  | ) |
| inline

Return the position from the current transformation matrix as an array of three floating point numbers.

This is simply returning the translation component of the 4x4 matrix.

Definition at line 305 of file vtkTransform.h.

## ◆ GetScale() [1/3]

void vtkTransform::GetScale | ( | double | scale[3] | ) |

Return the scale factors of the current transformation matrix as an array of three float numbers.

These scale factors are not necessarily about the x, y, and z axes unless unless the scale transformation was applied before any rotations.

## ◆ GetScale() [2/3]

void vtkTransform::GetScale | ( | float | scale[3] | ) |
| inline

Return the scale factors of the current transformation matrix as an array of three float numbers.

These scale factors are not necessarily about the x, y, and z axes unless unless the scale transformation was applied before any rotations.

Definition at line 320 of file vtkTransform.h.

## ◆ GetScale() [3/3]

double* vtkTransform::GetScale | ( |  | ) |
| inline

Return the scale factors of the current transformation matrix as an array of three float numbers.

These scale factors are not necessarily about the x, y, and z axes unless unless the scale transformation was applied before any rotations.

Definition at line 328 of file vtkTransform.h.

## ◆ GetInverse() [1/2]

void vtkTransform::GetInverse | ( | vtkMatrix4x4 * | inverse | ) |

Return a matrix which is the inverse of the current transformation matrix.

## ◆ GetTranspose()

void vtkTransform::GetTranspose | ( | vtkMatrix4x4 * | transpose | ) |

Return a matrix which is the transpose of the current transformation matrix.

This is equivalent to the inverse if and only if the transformation is a pure rotation with no translation or scale.

## ◆ SetInput()

void vtkTransform::SetInput | ( | vtkLinearTransform * | input | ) |

Set the input for this transformation.

This will be used as the base transformation if it is set. This method allows you to build a transform pipeline: if the input is modified, then this transformation will automatically update accordingly. Note that the InverseFlag, controlled via Inverse(), determines whether this transformation will use the Input or the inverse of the Input.

## ◆ GetInput()

vtkLinearTransform* vtkTransform::GetInput | ( |  | ) |
| inline

Set the input for this transformation.

This will be used as the base transformation if it is set. This method allows you to build a transform pipeline: if the input is modified, then this transformation will automatically update accordingly. Note that the InverseFlag, controlled via Inverse(), determines whether this transformation will use the Input or the inverse of the Input.

Definition at line 358 of file vtkTransform.h.

## ◆ GetInverseFlag()

vtkTypeBool vtkTransform::GetInverseFlag | ( |  | ) |
| inline

Get the inverse flag of the transformation.

This controls whether it is the Input or the inverse of the Input that is used as the base transformation. The InverseFlag is flipped every time Inverse() is called. The InverseFlag is off when a transform is first created.

Definition at line 368 of file vtkTransform.h.

## ◆ Push()

void vtkTransform::Push | ( |  | ) |
| inline

Pushes the current transformation onto the transformation stack.

Definition at line 374 of file vtkTransform.h.

## ◆ Pop()

void vtkTransform::Pop | ( |  | ) |
| inline

Deletes the transformation on the top of the stack and sets the top to the next transformation on the stack.

Definition at line 390 of file vtkTransform.h.

## ◆ CircuitCheck()

int vtkTransform::CircuitCheck | ( | vtkAbstractTransform * | transform | ) |
| overridevirtual

Check for self-reference.

Will return true if concatenating with the specified transform, setting it to be our inverse, or setting it to be our input will create a circular reference. CircuitCheck is automatically called by SetInput(), SetInverse(), and Concatenate(vtkXTransform *). Avoid using this function, it is experimental.

Reimplemented from vtkAbstractTransform.

## ◆ GetInverse() [2/2]

vtkAbstractTransform* vtkTransform::GetInverse | ( |  | ) |
| inline

Definition at line 413 of file vtkTransform.h.

## ◆ MakeTransform()

vtkAbstractTransform* vtkTransform::MakeTransform | ( |  | ) |
| overridevirtual

Make a new transform of the same type.

Implements vtkAbstractTransform.

## ◆ GetMTime()

vtkMTimeType vtkTransform::GetMTime | ( |  | ) |
| overridevirtual

Override GetMTime to account for input and concatenation.

Reimplemented from vtkAbstractTransform.

## ◆ MultiplyPoint() [1/2]

void vtkTransform::MultiplyPoint | ( | const float | in[4],
|  | float | out[4]
| ) |  |
| inline

Use this method only if you wish to compute the transformation in homogeneous (x,y,z,w) coordinates, otherwise use TransformPoint().

This method calls this->GetMatrix()->MultiplyPoint().

Definition at line 431 of file vtkTransform.h.

## ◆ MultiplyPoint() [2/2]

void vtkTransform::MultiplyPoint | ( | const double | in[4],
|  | double | out[4]
| ) |  |
| inline

Use this method only if you wish to compute the transformation in homogeneous (x,y,z,w) coordinates, otherwise use TransformPoint().

This method calls this->GetMatrix()->MultiplyPoint().

Definition at line 432 of file vtkTransform.h.

## ◆ InternalDeepCopy()

void vtkTransform::InternalDeepCopy | ( | vtkAbstractTransform * |  | ) |
| overrideprotectedvirtual

Perform any subclass-specific DeepCopy.

Reimplemented from vtkHomogeneousTransform.

## ◆ InternalUpdate()

void vtkTransform::InternalUpdate | ( |  | ) |
| overrideprotectedvirtual

Perform any subclass-specific Update.

Reimplemented from vtkAbstractTransform.

## Member Data Documentation

## ◆ Input

vtkLinearTransform* vtkTransform::Input
| protected

Definition at line 446 of file vtkTransform.h.

## ◆ Concatenation

vtkTransformConcatenation* vtkTransform::Concatenation
| protected

Definition at line 447 of file vtkTransform.h.

## ◆ Stack

vtkTransformConcatenationStack* vtkTransform::Stack
| protected

Definition at line 448 of file vtkTransform.h.

## ◆ MatrixUpdateMTime

vtkMTimeType vtkTransform::MatrixUpdateMTime
| protected

Definition at line 452 of file vtkTransform.h.

## ◆ Point

float vtkTransform::Point[4]
| protected

Definition at line 454 of file vtkTransform.h.

## ◆ DoublePoint

double vtkTransform::DoublePoint[4]
| protected

Definition at line 455 of file vtkTransform.h.

## ◆ ReturnValue

double vtkTransform::ReturnValue[4]
| protected

Definition at line 456 of file vtkTransform.h.

The documentation for this class was generated from the following file:

- Common/Transforms/vtkTransform.h